# TMVA reader

import ROOT
 
ROOT.TMVA.Tools.Instance()

reader = ROOT.TMVA.Reader()

# keeps objects otherwise removed by garbage collected in a list
gcSaver = []

import array
varx = array.array('f',[0]) ; reader.AddVariable("x",varx)
vary = array.array('f',[0]) ; reader.AddVariable("y",vary)

for method in {'Cuts','CutsD','CutsPCA','Fisher','FisherD','FisherPCA','BDT'}:
    
    reader.BookMVA(method,"dataset/weights/TMVAClassification_"+method+".weights.xml")
	
    # create a new 2D histogram with fine binning
    histo2 = ROOT.TH2F("histo2","",200,-5,5,200,-5,5)
     
    # loop over the bins of a 2D histogram
    for i in range(1,histo2.GetNbinsX() + 1):
        for j in range(1,histo2.GetNbinsY() + 1):
         
            # find the bin center coordinates
            varx[0] = histo2.GetXaxis().GetBinCenter(i)
            vary[0] = histo2.GetYaxis().GetBinCenter(j)
         
            # calculate the value of the classifier
            # function at the given coordinate
            Output = reader.EvaluateMVA(method,0.7)
            #print Output,varx[0],vary[0]
         
            # set the bin content equal to the classifier output
            histo2.SetBinContent(i,j,Output)
 
    gcSaver.append(ROOT.TCanvas(method,method,600,600))
    
    histo2.Draw("colz")
 

 
    #ROOT.gPad.Modified()


try:
    input("Press enter to continue")
except SyntaxError:
    pass

